//
// Protocol used by client app (e.g. PB) to communicate with
// the debugger.
//

@protocol DebuggerController <NSObject>

// execute cmd in gdb
- (oneway void) executeCmd:(NSString *)c	// execute this command string
                   withTty:(BOOL)t		// does gdb think it is from a tty
            withAnnotation:(BOOL)a;		// turn on annotation before command
						//  turn it off after command and
						//  print end of annotation to stdout.

- (oneway void)executeCmd:(NSString*)cmd
  withTty:(BOOL)tty
  withAnnotation:(BOOL)annotation
  catchOutput:(BOOL)catch;


// interrupt gdb, which in turn, interrupts the inferior
- (oneway void) interrupt;
@end
