/*
 * The following construct will normalize the values
 * of the options to 1 for the one in use, 0 for the others.
 * If none of the options is defined, it will cause a compile-time error.
 */

#if defined(MTHREAD)
#	if defined(COROUTINE) || defined(MTASK)
		compile_time_check() {
			undefined(UNIQUE_IMPLEMENTATION_OPTION);
		}
#	else
#		undef	MTHREAD
#		undef	COROUTINE
#		undef	MTASK
#		define	MTHREAD		1
#		define	COROUTINE	0
#		define	MTASK		0
#	endif
#else
#if defined(COROUTINE)
#	if defined(MTASK)
		compile_time_check() {
			undefined(UNIQUE_IMPLEMENTATION_OPTION);
		}
#	else
#		undef	MTHREAD
#		undef	COROUTINE
#		undef	MTASK
#		define	MTHREAD		0
#		define	COROUTINE	1
#		define	MTASK		0
#	endif
#else
#if defined(MTASK)
#	undef	MTHREAD
#	undef	COROUTINE
#	undef	MTASK
#	define	MTHREAD		0
#	define	COROUTINE	0
#	define	MTASK		1
#else
	compile_time_check() {
		undefined(IMPLEMENTATION_OPTION);
	}
#endif
#endif
#endif

/*
 * The following options should be defined
 * as 1 to enable, 0 to disable.
 */
#define	IPC_WAIT	1
#define	SCHED_HINT	0
